version: '3.8'
services:
  frontend:
    build:
      context: ./frontend
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "yarn install && yarn serve"
    ports:
      - 3000:8080
    volumes:
      - ./frontend:/usr/local/src
    environment:
      - NODE_ENV=local
      - VUE_APP_API_BASE_URL=http://localhost:8000/api/v1
    depends_on:
      - proxy

  proxy:
    image: nginx:1.19-alpine
    volumes:
      - ./proxy/nginx.conf:/etc/nginx/conf.d/default.conf
    ports:
      - 8000:80
    depends_on:
      - catalog-api
      - products-api
      - warehouse-api
      - ratings-api
      - orders-api

  products:
    build: 
      context: ./products
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "./wait-for-it.sh -t 300 mysql:3306 && /usr/bin/composer install && php /usr/local/src/products/artisan migrate --force && php-fpm"
    volumes:
      - ./products:/usr/local/src/products
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=products
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql

  products-api:
    image: nginx:1.19-alpine
    volumes:
      - ./products:/usr/local/src/products
      - ./products/docker/nginx/conf.d:/etc/nginx/conf.d
    ports:
      - 8001:80
    depends_on:
      - products

  ratings:
    build: 
      context: ./ratings
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "./wait-for-it.sh -t 300 mysql:3306 && /usr/bin/composer install && php /usr/local/src/ratings/artisan migrate --force && php-fpm"
    volumes:
      - ./ratings:/usr/local/src/ratings
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=ratings
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql

  ratings-api:
    image: nginx:1.19-alpine
    volumes:
      - ./ratings:/usr/local/src/ratings
      - ./ratings/docker/nginx/conf.d:/etc/nginx/conf.d
    ports:
      - 8002:80
    depends_on:
      - ratings

  ratings-consumer:
    build: 
      context: ./ratings
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "sleep 10 && php /usr/local/src/ratings/artisan redis:consume"
    restart: unless-stopped
    volumes:
      - ./ratings:/usr/local/src/ratings
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=ratings
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql
      - redis
      - ratings

  warehouse:
    build: 
      context: ./warehouse
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "./wait-for-it.sh -t 300 mysql:3306 && /usr/bin/composer install && php /usr/local/src/warehouse/artisan migrate --force && php-fpm"
    volumes:
      - ./warehouse:/usr/local/src/warehouse
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=warehouse
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql

  warehouse-api:
    image: nginx:1.19-alpine
    volumes:
      - ./warehouse:/usr/local/src/warehouse
      - ./warehouse/docker/nginx/conf.d:/etc/nginx/conf.d
    ports:
      - 8003:80
    depends_on:
      - warehouse

  warehouse-consumer:
    build: 
      context: ./warehouse
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "sleep 10 && php /usr/local/src/warehouse/artisan redis:consume"
    restart: unless-stopped
    volumes:
      - ./warehouse:/usr/local/src/warehouse
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=warehouse
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql
      - redis
      - warehouse

  catalog:
    build: 
      context: ./catalog
      dockerfile: ./docker/Dockerfile
    volumes:
      - ./catalog:/usr/local/src/catalog
    entrypoint: sh -c "/usr/bin/composer install && php-fpm"
    environment:
      - SERVICES_PRODUCTS_URL=http://products-api/api/v1/
      - SERVICES_WAREHOUSE_URL=http://warehouse-api/api/v1/
      - SERVICES_RATINGS_URL=http://ratings-api/api/v1/
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql

  catalog-api:
    image: nginx:1.19-alpine
    volumes:
      - ./catalog:/usr/local/src/catalog
      - ./catalog/docker/nginx/conf.d:/etc/nginx/conf.d
    ports:
      - 8004:80
    depends_on:
      - catalog

  orders:
    build:
      context: ./orders
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "./wait-for-it.sh -t 300 mysql:3306 && /usr/bin/composer install && php /usr/local/src/orders/artisan migrate --force && php-fpm"
    volumes:
      - ./orders:/usr/local/src/orders
    environment:
      - SERVICES_WAREHOUSE_URL=http://warehouse-api/api/v1/
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=orders
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql

  orders-api:
    image: nginx:1.19-alpine
    volumes:
      - ./orders:/usr/local/src/orders
      - ./orders/docker/nginx/conf.d:/etc/nginx/conf.d
    ports:
      - 8005:80
    depends_on:
      - orders

  orders-consumer:
    build:
      context: ./orders
      dockerfile: ./docker/Dockerfile
    entrypoint: sh -c "sleep 10 && php /usr/local/src/orders/artisan redis:consume"
    restart: unless-stopped
    volumes:
      - ./orders:/usr/local/src/orders
    environment:
      - APP_ENV=local
      - APP_KEY=base64:7t3iJGYKu1jqjeEQixGEL8mXwCr6XgVRmd6ryRII3Jo=
      - APP_DEBUG=true
      - DB_CONNECTION=mysql
      - DB_HOST=mysql
      - DB_PORT=3306
      - DB_DATABASE=orders
      - DB_USERNAME=root
      - DB_PASSWORD=root
      - REDIS_HOST=redis
      - REDIS_PASSWORD=null
      - REDIS_PORT=6379
      - REDIS_CLIENT=phpredis
      - REDIS_SCHEME=tcp
      - LOG_CHANNEL=stack
      - LOG_LEVEL=debug
    depends_on:
      - mysql
      - redis
      - warehouse

  mysql:
    image: mysql:8
    platform: linux/x86_64
    volumes: 
      - ./bin/mysql:/docker-entrypoint-initdb.d
      - ./mysqldata:/var/lib/mysql
    ports:
      - 33060:3306
    environment:
      - MYSQL_ROOT_PASSWORD=root

  redis:
    image: redis:6.2.5-alpine
    platform: linux/x86_64
    volumes:
      - ./redisdata:/data
    ports:
      - 63790:6379

  phpmyadmin:
    image: phpmyadmin    
    platform: linux/x86_64
    ports:
      - 8080:80
    environment:
      - PMA_HOST=mysql
    depends_on:
      - mysql

  redis-commander:
    image: rediscommander/redis-commander:latest
    platform: linux/x86_64
    hostname: redis-commander
    environment:
      - REDIS_HOSTS=local:redis:6379
    ports:
      - 63791:8081
    depends_on:
      - redis

  mysql-test:
    image: mysql:8
    platform: linux/x86_64
    volumes:
      - ./bin/mysql:/docker-entrypoint-initdb.d
    environment:
      - MYSQL_ROOT_PASSWORD=root

  redis-test:
    image: redis:6.2.5-alpine
    platform: linux/x86_64